--CombatAssist v2.0
--By Calder Coalson
--With many thanks to Denji, Enois, Mick, Miharu, Spidey and others

declare("ca", {})

ca.faignore = false
ca.dist = 0
ca.keys = {}

function ca.modetoggle ()
	if ca.mode == 0 then
		ca.mode = 1
		print("\127"..ca.color.."Combat Assist Mode: DISTANCE CONTROL")
		ca.keepDistance()
	elseif ca.mode == 1 then
		ca.mode = 0
		print("\127"..ca.color.."Combat Assist Mode: DIRECT CONTROL")
	end
end

function ca.toggle ()
--toggle CA on/off
	if ca.on then
		ca.on = false
		gkinterface.GKProcessCommand("Accel 0")
		--bind normal key config
		gkinterface.GKProcessCommand("bind ".. ca.keys.stop .." +Brakes")
		gkinterface.GKProcessCommand("bind ".. ca.keys.forward .." +Accelerate")
		gkinterface.GKProcessCommand("bind ".. ca.keys.reverse .." +Decelerate")
		print("\127"..ca.color.."Combat Assist Mode: OFF")
	else
		ca.on = true
		ca.faignore = true
		Game.SetCVar("flymodeflag", 0)
		--bind CA keys		
		gkinterface.GKProcessCommand("bind ".. ca.keys.stop .." stop")
		gkinterface.GKProcessCommand("bind ".. ca.keys.forward .." forward")
		gkinterface.GKProcessCommand("bind ".. ca.keys.reverse .." reverse")
		print("\127"..ca.color.."Combat Assist Mode: ON")
		if ca.mode == 1 then
			print("\127"..ca.color.."Combat Assist Mode: DISTANCE CONTROL")
			print("\127"..ca.color.."Holding at " .. ca.distance .. "m")
			ca.keepDistance()
		elseif ca.mode == 0 then
			print("\127"..ca.color.."Combat Assist Mode: DIRECT CONTROL")
		end
	end
end

function ca.forward ()
	if ca.mode == 0 then
		gkinterface.GKProcessCommand("Accel 1000")
		if ca.verbose then print("\127"..ca.color.."Lateral Thrusters: FORWARD") end
	elseif ca.mode == 1 then
		if ca.distance > 0 then
			ca.distance = ca.distance - ca.increment
		end
		print("\127"..ca.color.."Holding at " .. ca.distance .. "m")
	end
end

function ca.stop ()
	if ca.mode == 0 then
		gkinterface.GKProcessCommand("Accel 0")
		if ca.verbose then print("\127"..ca.color.."Lateral Thrusters: NEUTRAL") end
	elseif ca.mode == 1 then
		ca.distance = ca.dflt
		print("\127"..ca.color.."Holding at " .. ca.distance .. "m")
	end
end

function ca.reverse ()
	if ca.mode == 0 then
		gkinterface.GKProcessCommand("Accel -1000")
		if ca.verbose then print("\127"..ca.color.."Lateral Thrusters: REVERSE") end
	elseif ca.mode == 1 then
		if ca.distance < 1000 then
			ca.distance = ca.distance + ca.increment
		end
		print("\127"..ca.color.."Holding at " .. ca.distance .. "m")
	end
end

function ca.keepDistance ()
	if ca.mode == 1 and ca.on then
		if GetTargetDistance() then
			local dist = GetTargetDistance() - ca.distance
			ca.dist = dist
			--if too far or too close, automatically go towards center
			if dist > ca.increment/2 then
				gkinterface.GKProcessCommand("Accel +1000")
			elseif dist < -ca.increment/2 then
				gkinterface.GKProcessCommand("Accel -1000")
			else
			--if within margin, then use rate rate of change
				if dist - ca.dist > 0 then
					gkinterface.GKProcessCommand("Accel 1000")
				elseif dist - ca.dist < 0 then
					gkinterface.GKProcessCommand("Accel 0")
				else
					gkinterface.GKProcessCommand("Accel 0")
				end
			end
		end
		local timer = Timer()
		timer:SetTimeout(1000*ca.refresh, ca.keepDistance)
	end
end

function ca:OnEvent (event, arg1, arg2)
--handle user turning FA on
	if event == "FLIGHT_MODE_CHANGED" then
		if ca.on then
			if not ca.faignore then
			--ignore if changed by ca.toggle()
				ca.toggle()
			else
				ca.faignore = false
			end
		elseif ca.autoOn and not ca.on and ca.faon then
			ca.toggle()
		end
	end
end

RegisterUserCommand("fightmode", ca.modetoggle)
RegisterUserCommand("fight", ca.toggle)
RegisterUserCommand("stop", ca.stop)
RegisterUserCommand("forward", ca.forward)
RegisterUserCommand("reverse", ca.reverse)
RegisterEvent(ca, "FLIGHT_MODE_CHANGED")

dofile("options.lua")
ca.dflt = ca.distance

gkinterface.GKProcessCommand("bind ".. ca.keys.toggle .." fight")
gkinterface.GKProcessCommand("bind ".. ca.keys.modeswitch .." fightmode")
--bind initial keys
ca.on = true
Game.SetCVar("flymodeflag", 1)
